;		TITLE  '(C) DDS SWEEPER G3RFL 15/1/2015'			
;		V1	using dsPIC30F4012 Micro and AD9835 DDS 3/2/2015

;***************************** NOTE ******************************
;		V2 to follow that auto scans and line number scope output settable

;-----------------------------------------------------------------------------
       .equ __30F4012, 1
        .include "p30f4012.inc"
;-------------- global declarations ---------------------------------------
	.global __reset
	.global __T1Interrupt
;--------------------------------------------------------
;	Configuration bits
;--------------------------------------------------------
	config __FOSC, CSW_FSCM_OFF & FRC_PLL16
	config __FWDT,WDT_OFF
	config __PBORPOR, PBOR_OFF & MCLR_EN
	config __FGS, CODE_PROT_OFF	
;--------------------------------------------------------
;..............................................................................
;Constants stored in Program space

        .section .myconstbuffer, psv
;------ general Constants -----------------------------
;define constant
;PORTB
	.equ	ANAL0, 0
	.equ	ANAL1, 1
	.equ	PB1, 2
	.equ	PB2, 3
	.equ	PB3, 4
	.equ	PB4, 5
;PORTC
	.equ	PGD, 6
	.equ	PGC, 7
	.equ	SCL,13
	.equ	SDA,15
;PORTD
	.equ	A_B, 0
	.equ	SCOPE,1
;PORTE
	.equ	SCLK, 0
	.equ	SDATA, 1
	.equ	FSYNC,2
	.equ	FSELECT,3
	.equ	PSEL1,4
	.equ	PSEL0,5
	.equ	VSYNC, 8
;------ I/O Port constants -----------------------------
;define ram assignments
	.bss	dig1,2
	.bss	dig2,2
	.bss	dig3,2
	.bss	dig4,2
	.bss	dig5,2
	.bss	dig6,2
	.bss	dig7,2
	.bss	dig8,2
	.bss	dig9,2
	.bss	dig10,2
	.bss	dig11,2
	.bss	delay1,2
	.bss	delay2,2
	.bss	datbuff,2
	.bss	temp1,2
	.bss	temp2,2
	.bss	temp3,2
	.bss	temp4,2
	.bss	temp5,2
	.bss	count,4
	.bss	upper,2
	.bss	lower,2
	.bss	line_1,2	;1st Row display ram
	.bss	line_2,2
	.bss	line_3,2
	.bss	line_4,2
	.bss	line_5,2
	.bss	line_6,2
	.bss	line_7,2
	.bss	line_8,2
	.bss	line_9,2
	.bss	line_10,2
	.bss	line_11,2
	.bss	line_12,2
	.bss	line_13,2
	.bss	line_14,2
	.bss	line_15,2
	.bss	line_16,2
	.bss	line_17,2	;2nd Row display ram
	.bss	line_18,2
	.bss	line_19,2
	.bss	line_20,2
	.bss	line_21,2
	.bss	line_22,2
	.bss	line_23,2
	.bss	line_24,2
	.bss	line_25,2
	.bss	line_26,2
	.bss	line_27,2
	.bss	line_28,2
	.bss	line_29,2
	.bss	line_30,2
	.bss	line_31,2
	.bss	line_32,2
	.bss	task,2
	.bss	flags,2
	.bss	toggle,2
	.bss	pdbm,2
	.bss	block,2
	.bss	remainder,2
	.bss	add_toggle,2
	.bss	t0,2
	.bss	t1,2
	.bss	t2,2
	.bss	t3,2
	.bss	t4,2
	.bss	t5,2
	.bss	t6,2
	.bss	t7,2
	.bss	t8,2
	.bss	t9,2
	.bss	t10,2
	.bss	stat_numb,2
	.bss	byte1,2
	.bss	byte2,2
	.bss	byte3,2
	.bss	byte4,2
	.bss	byte5,2
	.bss	byte6,2

	.bss	button,2
	.bss	butval,2
	.bss	freqval,2
	.bss	menuval,2
;------------------------------------------------------
;	       		28 PIN DIL 
;			dsPIC30F4012
;                     ______  ______
;		     |      \/      |
;   PROGRAMER/MCLR --+ 1         28 +-- RB7  AVdd	
;	             |              |
;              RB0 --+ 2         27 +-- RB6  AVss
;	             |              |
;         BUT1/RB1 --+ 3         26 +-- RE0/SCLK 		
;	             |              |
;         BUT2/RB2 --+ 4         25 +-- RE1/SDATA  
;	             |              |
;    	  BUT3/RB3 --+ 5         24 +-- RE2/FSYNC	  
;	             |              |
;         BUT4/RB4 --+ 6         23 +-- RE3/FSELECT
;	             |              |
;         BUT5/RB5 --+ 7         22 +-- RE4/PSEL1
;	             |              |
;              VSS  -+ 8         21 +-- RE5/PSEL0
;	             |              |
;              OSC --+ 9         20 +-- VDD
;	             |              |
;         SDA/RC15 --+ 10        19 +-- VSS
;	             |              |
;         SCL/RC13 --+ 11        18 +-- RC7/PGC	
;	             |              |
;             RC14 --+ 12        17 +-- RC6/PGD
;	             |              |
;              VDD --+ 13        16 +-- RE8/VSYNC
;	             |              |
;        SCOPE/RD1 --+ 14        15 +-- RD0/A_B	       	
;                    |______________|

;			AD9835
;                     ______  ______
;		     |      \/      |
;           FS ADJ --+ 1         16 +-- COMP	
;	             |              |
;           IREFIN --+ 2         15 +-- VDD
;	             |              |
;          IREFOUT --+ 3         14 +-- IOUT		
;	             |              |
;              VDD --+ 4         13 +-- VSS
;	             |              |
;    	       VSS --+ 5         12 +-- PSEL0
;	             |              |
;   	      MCLK --+ 6         11 +-- PSEL1
;	             |              |
;              SCL --+ 7         10 +-- FSELECT
;	             |              |
;              SDA  -+ 8          9 +-- FSYNC
;	             |______________|

;			MAX4023
;                     ______  ______
;		     |      \/      |
;              AIN --+ 1         16 +-- A/FB1	
;	             |              |
;              VSS --+ 2         15 +-- A/BOUT
;	             |              |
;              VSS --+ 3         14 +-- VDD		
;	             |              |
;              VSS --+ 4         13 +-- VDD
;	             |              |
;    	       A/B --+ 5         12 +-- 
;	             |              |
;   	       BIN --+ 6         11 +-- 
;	             |              |
;              VSS --+ 7         10 +-- 
;	             |              |
;              VSS  -+ 8          9 +-- 
;	             |______________|

;-------------------------------------------------------
	.text	;start of code
;-----------------------------------------
__reset:
	call	delay
        mov 	#__SP_init, W15       	;Initalize the Stack Pointer
        mov 	#__SPLIM_init, W0     	;Initialize the Stack Pointer Limit Register
        mov 	W0, SPLIM
        nop                     	;Add NOP to follow SPLIM initialization
	mov	#0xffff,w0		
	mov	w0,ADPCFG		
	clr	LATB
	clr	LATC
	clr	LATD
	clr	LATE
	bset    CORCON, #PSV              ;Enable Program Space Visibility
	bra	init	                                 
;----------------------- Initialisation Routine -----------------------
init:
	call	delay
	rcall	init_ports
	rcall	stop_LCD
	call	LCD_detect
	rcall	init_lcd
	clr	dig1
	clr	dig2
	clr	dig3
	clr	dig4
	clr	dig5
	clr	dig6
	clr	dig7
	clr	dig8
	clr	dig9
	clr	dig10
	clr	dig11
	clr	freqval
	mov	#16,w0
	mov	w0,menuval
	clr	flags
	clr	stat_numb
	clr	byte6
	clr	byte1
	mov	#0x20,w0
	mov	w0,byte2
	call	set_freq
	goto	main
;-------------------- increment freq ------------------
set_freq:
	mov	#0xd0,w0
	mov	#0x00,w1
	call	bit_16



	mov	#0x33,w0	;H MSB
	mov	byte1,w1
	call	bit_16

	mov	#0x22,w0	;L MSB
	mov	byte2,w1
	call	bit_16



	mov	#0x30,w0	;H LSB
	mov	#0x20,w1
	call	bit_16
	mov	#0x20,w0	;L LSB
	mov	#0x00,w1
	call	bit_16

	mov	#0x90,w0
	mov	#0x00,w1
	call	bit_16

	mov	#0xc0,w0
	mov	#0x00,w1
	call	bit_16
	return		
;------------------------------
init_freq:
	mov	#0xd0,w0
	mov	#0x00,w1
	call	bit_16

	mov	#0x33,w0	;H MSB
	mov	#0x00,w1
	call	bit_16
	mov	#0x33,w0	;L MSB
	mov	byte2,w1
	call	bit_16

	mov	#0x30,w0	;H LSB
	mov	#0x00,w1
	call	bit_16
	mov	#0x20,w0	;L LSB
	mov	#0x00,w1
	call	bit_16

	mov	#0x90,w0
	mov	#0x00,w1
	call	bit_16

	mov	#0xc0,w0
	mov	#0x00,w1
	call	bit_16
	return
;------------------------------
bit_16:
	call	fsync_start
	mov	w0,temp1
	mov	#8,w0
	mov	w0,temp2
lp1:
	bclr	LATE,#SDATA
	btst	temp1,#7
	bra	z,sk1
	bset	LATE,#SDATA
sk1:
	call	sclk
	sl	temp1
	dec	temp2
	bra	nz,lp1
	mov	w1,temp1
	mov	#8,w0
	mov	w0,temp2
lp2:
	bclr	LATE,#SDATA
	btst	temp1,#7
	bra	z,sk2
	bset	LATE,#SDATA
sk2:
	call	sclk
	sl	temp1
	dec	temp2
	bra	nz,lp2
	call	fsync_stop
	return
fsync_start:
	bclr	LATE,#FSYNC
	nop
	nop
	return
fsync_stop:
	bset	LATE,#FSYNC
	nop
	nop
	nop
	return
;---------------------- Clear DDS sdata ----------------------
clrdata:
	bclr	LATE,#SDATA
	return
;-------------------- Serial DDS clock -----------------------
sclk:
	bset	LATE,#SCLK
	nop
	nop
	nop
	nop
	bclr	LATE,#SCLK
	return
;-------------------- main routines -----------------
;
;--------------------- get button status -------------------
buttons:
	mov	PORTB,w0
	mov	w0,butval
	lsr	butval
	lsr	butval
	com	butval
	call	butsort
	return
;---------------------- munu 
menu:
	call	start_LCD
	call	header_LCD
	call	LCD_Line1
	mov	menuval,w0
	call	PrintString
	call	stop_LCD

	call	start_LCD
	call	header_LCD
	call	LCD_Line2
	mov	freqval,w0
	call	PrintString
	call	stop_LCD
	return
;--------------------- sort out buttons ---------------------
butsort:
	btsc	butval,#3	;PB1 MENU
	goto	inct1
	btsc	butval,#2	;PB2 INC
	goto	inct2
	btsc	butval,#1	;PB3 DEC
	goto	inct3
	btsc	butval,#0	;PB4 SELECT
	goto	inct4
	return
inct1:
;	inc	menuval
;	mov	menuval,w0
;	call	PrintString
;	call	butdly
	return

inct2:
	inc	freqval

decdec:
	mov	freqval,w4
	mov	#0x00,w5	;20.KHz
	cp	w4,w5
	bra	nz,p0
	
	mov	#0x00,w0	
	mov	w0,byte1
	mov	#0x20,w0
	goto	aaa
p0:

	mov	freqval,w4
	mov	#0x01,w5	;62.5KHz
	cp	w4,w5
	bra	nz,p1
	
	mov	#0x00,w0	
	mov	w0,byte1
	mov	#0x66,w0
	goto	aaa
p1:
	mov	#0x02,w5	;125KHz	
	cp	w4,w5
	bra	nz,p2
	
	mov	#0x00,w0	
	mov	w0,byte1
	mov	#0xcd,w0
	goto	aaa
p2:
	mov	#0x03,w5	;250KHz
	cp	w4,w5
	bra	nz,p3
	
	mov	#0x01,w0	
	mov	w0,byte1
	mov	#0x9a,w0
	goto	aaa
p3:
	mov	#0x04,w5	;500KHz
	cp	w4,w5
	bra	nz,p4
	
	mov	#0x03,w0	
	mov	w0,byte1
	mov	#0x34,w0
	goto	aaa
p4:
	mov	#0x05,w5	;1MHz
	cp	w4,w5
	bra	nz,p5
	
	mov	#0x06,w0	
	mov	w0,byte1
	mov	#0x67,w0
	goto	aaa
p5:
	mov	#0x06,w5	;2MHz
	cp	w4,w5
	bra	nz,p6
	
	mov	#0x0c,w0	
	mov	w0,byte1
	mov	#0xce,w0
	goto	aaa
p6:
	mov	#0x07,w5	;3MHz
	cp	w4,w5
	bra	nz,p7
	
	mov	#0x13,w0	
	mov	w0,byte1
	mov	#0x34,w0
	goto	aaa
p7:
	
	mov	#0x08,w5	;4MHz
	cp	w4,w5
	bra	nz,p8
	
	mov	#0x19,w0	
	mov	w0,byte1
	mov	#0x9b,w0
	goto	aaa
p8:
	mov	#0x09,w5	;4.3MHz
	cp	w4,w5
	bra	nz,p9
	
	mov	#0x1b,w0	
	mov	w0,byte1
	mov	#0x86,w0
	goto	aaa
p9:
	mov	#0x0a,w5	;5MHz
	cp	w4,w5
	bra	nz,p10
	
	mov	#0x20,w0	
	mov	w0,byte1
	mov	#0x01,w0
	goto	aaa
p10:
	mov	#0x0b,w5	;6MHz
	cp	w4,w5
	bra	nz,p11
	
	mov	#0x26,w0	
	mov	w0,byte1
	mov	#0x67,w0
	goto	aaa
p11:
	mov	#0x0c,w5	;6.5MHz
	cp	w4,w5
	bra	nz,p12
	
	mov	#0x29,w0	
	mov	w0,byte1
	mov	#0x9a,w0
	goto	aaa
p12:
	mov	#0x0d,w5
	cp	w4,w5
	bra	nz,p13
	
	mov	#0x02,w0	
	mov	w0,byte1
	mov	#0x04,w0
	goto	aaa
p13:
	clr	freqval	

;----------------
aaa:
	mov	w0,byte2
	call	set_freq
	call	menu
	call	butdly
	return
;---------------




inct3:
	dec	freqval
	goto	decdec
inct4:
	mov	#03,w0
	mov	w0,byte6
	call	butdly
	return
;-------------------- button delay -----------------
butdly:
	clr	delay1
	mov	#80,w0
	mov	w0,delay2
lpbut:
	dec	delay1
	bra	nz,lpbut
	dec	delay2
	bra	nz,lpbut
	return

;-------------------- main routines -----------------
main:
	call	buttons
	call	scopeon

	bclr	LATD,#A_B
	call	equal_sync	;1
	call	equal_sync
	call	equal_sync	;2
	call	equal_sync
	call	equal_sync	;3

	call	equal_black
	call	equal_black	;4
	call	equal_black
	call	equal_black	;5
	call	equal_black


	call	black_lineb	;6
	call	black_lineb	;7
	call	black_lineb	;8
	call	black_lineb	;9

	call	scopeoff

	call	black_lineb	;10
	call	black_lineb	
	call	black_lineb	
	call	black_lineb	
	call	black_lineb	
	call	black_lineb	
	call	black_lineb	
	call	black_lineb	
	call	black_lineb	
	call	black_lineb	

	call	black_lineb	;20
	call	black_lineb	
	call	black_lineb	
	bset	LATD,#A_B	
	call	black_line
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line
	
	call	black_line	;30

	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line
	
	call	black_line	;40
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;50
	call	black_line	
	call	black_line	
;	call	hsync_2		
	call	black_line
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;60
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;70
	call	black_line	
	call	black_line		
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;80
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;90
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;100
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;110
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;120
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;130
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;140
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;150
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;160
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;170
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;180
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;190
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;200
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;210
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;220
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;230
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;240
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;250
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;260
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;270
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;280
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;290
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;300
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line
	call	black_line
	call	black_line	
	call	black_line
;	call	inc_freq
	bclr	LATD,#A_B	
	call	black_lineb	;310

	call	equal_black	;311
	call	equal_black	;
	call	equal_black	;312
	call	equal_black	;
	call	equal_black	;313
	call	equal_sync	;
	call	equal_sync	;314
	call	equal_sync	;
	call	equal_sync	;315
	call	equal_sync	;

	call	equal_black	;316
	call	equal_black	;
	call	equal_black	;317
	call	equal_black	;

	call	black_lineb	;318
	call	black_lineb	;319


	call	black_lineb	;320
	call	black_lineb	
	call	black_lineb	
	call	black_lineb	
	call	black_lineb	
	call	black_lineb	
	call	black_lineb	
	call	black_lineb	
	call	black_lineb	
	call	black_lineb	

	call	black_lineb	;330
	call	black_lineb	
	call	black_lineb	
	call	black_line

	bset	LATD,#A_B	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;340
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;350
	call	black_line	
	call	black_line	
;	call	hsync_2	
	call	black_line
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;360
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;370
	call	black_line	
	call	black_line	
	call	black_line
;	call	hsync_3	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;380
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;390
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;400
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;410
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;420
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;430
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;440
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;450
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;460
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;470
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;480
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;490
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;500
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;510
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;520
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;530
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;540
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;550
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;560
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;570
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;580
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;590
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;600
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	

	call	black_line	;610
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	
	call	black_line	;620
	call	black_line
	bclr	LATD,#A_B	
	call	black_lineb	
	call	equal_black	;623
	call	equal_black	;
	call	equal_black	;624
	call	equal_black	;
	call	equal_black	;625
	goto	main
;------	Various Output Routines --------------------------------
black_line:			
	bclr	LATD,#A_B
	call	delay2us	
	bclr	LATE,#VSYNC	
	call	delay5us		
	bset	LATE,#VSYNC	
	call	delay6us
	bset	LATD,#A_B
	repeat	#1575
	nop
	return
black_lineb:			
	bclr	LATD,#A_B
	call	delay2us
	bclr	LATE,#VSYNC	
	call	delay5us					
	bset	LATE,#VSYNC
	repeat	#1575
	nop
	return
;----------------------------		
equal_black:			
	bclr	LATE,#VSYNC	
	call	delay4us					
	bset	LATE,#VSYNC	
	call	delay10us	
	call	delay10us	
	call	delay6us	
	return			
equal_sync:			
	bclr	LATE,#VSYNC	
	call	delay10us	
	call	delay10us	
	call	delay8us					
	bset	LATE,#VSYNC
	call	delay4us		
	return

;---------------- Detect LCD type ----------
LCD_detect:
	clr	add_toggle
	call	start_LCD
	mov	#0x7e,w0	;lcd address
	mov	w0,temp2	;this will get destroyed
	mov	#0x08,w0	;send 8 bits
	mov	w0,temp1
send8_i2c0:
	bclr	LATC,#SDA
	btsc	temp2,#0x07
	bset	LATC,#SDA	;set data bit	
	sl	temp2	
	call	i2c_clk_LCD
	dec	temp1
	bra	nz,send8_i2c0
	bset	LATC,#SDA
	bset	LATC,#SCL
	call	I2C_dly
	btsc	PORTC,#SDA
	bset	add_toggle,#0
	bclr	LATC,#SCL	;LCD clock pulse
	call	stop_LCD
	return
;------------------ INIT LCD START ADDRESS -------------------
CG_ram:
	mov	#0x40,w0	;send address to control register
	call	bld_command
	return
LCD_Line1:
	mov	#0x80,w0	;send address to control register
	call	bld_command
	return
LCD_Line2:
	mov	#0xc0,w0	;send address to control register
	call	bld_command
	return
;---------------------------- Sends Message Number W0 to LCD Display -------------
PrintString:
	bset    CORCON, #PSV            ;Enable Program Space Visibility
    	mov     #psvpage(strings), W1   ;Set Program Space Visibility Page
    	mov     W1, PSVPAG              ;
   	mov     #psvoffset(strings),W1  ;Get Address of First Message into W1
    	sl      W0,#4,W0                ;W0 = W0 * 16
    	add     W0,W1,W1                ;W1 = W1 + W0            ;W1 is now base address of ascii           
	mov	#16,w2			;send all 16 characters
send16:
	mov.b	[w1++],w0
	call	bld_byte
	dec	w2,w2
	bra	nz,send16
	return
;-----------------------------------------------------
init_lcd:
;		01	REGISTER SELECT
;		02	READ/WRITE SELECT
;		04	ENABLE BIT
	call	start_LCD
	call	header_LCD	;send i2c address "7E"
	mov	#0x38,w0
	mov	w0,datbuff	;set DL to be 4 bit
	call	sendlcd
	mov	#0x38,w0
	mov	w0,datbuff	;1
	call	sendlcd
	mov	#0x04,w0
	mov	w0,datbuff	;2
	call	sendlcd
	mov	#0x08,w0
	mov	w0,datbuff	;3
	call	sendlcd
	mov	#0x04,w0 
	mov	w0,datbuff	;4
	call	sendlcd
	mov	#0x00,w0
	mov	w0,datbuff	;5
	call	sendlcd
	mov	#0x24,w0
	mov	w0,datbuff	;6
	call	sendlcd
	mov	#0x00,w0
	mov	w0,datbuff	;7
	call	sendlcd
	mov	#0x1c,w0
	mov	w0,datbuff	;8
	call	sendlcd
	mov	#0x08,w0
	mov	w0,datbuff	;9
	call	sendlcd
	mov	#0x0d,w0
	mov	w0,datbuff	;a
	call	sendlcd
	mov	#0x09,w0
	mov	w0,datbuff	;b
	call	sendlcd
	call	stop_LCD
	return
;------------------------------
cg_write:
bld_byte:
	mov	w0,upper	;send data
	sl	w0,#4,w0
	mov	w0,lower
	bset	lower,#0
	bclr	lower,#1
	bset	lower,#2
	bset	lower,#3		
	bset	upper,#0	;read data
	goto	ext
;------------------------------
bld_command:
	mov	w0,upper	;send command
	sl	w0,#4,w0
	mov	w0,lower
	bclr	lower,#0
	bclr	lower,#1
	bset	lower,#2
	bset	lower,#3		
	bclr	upper,#0	;write command
ext:
	bclr	upper,#1
	bset	upper,#2
	bset	upper,#3
	mov	upper,w0
	mov	w0,datbuff
	call	sendlcd
	bclr	upper,#2
	mov	upper,w0
	mov	w0,datbuff
	call	sendlcd
	mov	lower,w0
	mov	w0,datbuff
	call	sendlcd
	bclr	lower,#2
	mov	lower,w0
	mov	w0,datbuff
	call	sendlcd	
	return
;------------------------------
header_LCD:
	mov	#0x7e,w0	;lcd address
	btsc	add_toggle,#0
	mov	#0x4e,w0	;lcd address
	mov	w0,datbuff
	call	sendlcd		;send 7e address to i2c chip
	return
;---------------------------------
sendlcd:
	mov	datbuff,w0	;saved data
send_LCD:
	mov	w0,temp2	;this will get destroyed
	mov	#0x08,w0	;send 8 bits
	mov	w0,temp1
send8_i2c:
	bclr	LATC,#SDA
	btsc	temp2,#0x07
	bset	LATC,#SDA	;set data bit	
	sl	temp2	
	call	i2c_clk_LCD
	dec	temp1
	bra	nz,send8_i2c
	bset	LATE,#SDA
	call	i2c_clk_LCD	;ack bit clock
	return
;----------------------
start_i2c:
start_LCD:
	bclr	LATC,#SDA
	call	I2C_dly
	bclr	LATC,#SCL	;LCD start condition
	return
;----------------------
stop_i2c:
stop_LCD:
	bset	LATC,#SCL
	call	I2C_dly
	bset	LATC,#SDA	;LCD stop condition
	return
;---------------------------------------------------------
i2c_clk:
i2c_clk_LCD:
	bset	LATC,#SCL
	call	I2C_dly
	bclr	LATC,#SCL	;LCD clock pulse
	call	I2C_dly
	return
;---------------------- scope trigger --------------
scopeon:
	bset	LATD,#SCOPE
	return
scopeoff:
	bclr	LATD,#SCOPE
	return
;--------------------------- SET UP PORTS -----------------
init_ports:
	clr	PTCON
	clr	PWMCON1
	clr	OVDCON
	clr	LATB
	clr	LATD
	mov	#0xff,w0	; 0=output 1=input
	mov	w0,TRISB	
	mov	#0x00,w0
	mov	w0,TRISC
	mov	w0,TRISD
	mov	w0,TRISE
	call	stop_LCD
	bset	CNPU1,#3
	bset	CNPU1,#4
	bset	CNPU1,#5
	bset	CNPU1,#6	;input pull-upps RBX
	bset	CNPU1,#7
	return
;-----------------------------
I2C_dly:
	repeat	#200
	nop
	return
;--------------------------
delay:
	clr	delay1
	clr	delay2
	inc	delay2
	inc	delay2
	inc	delay2
	inc	delay2
lp256:
	dec	delay1
	bra	nz,lp256
	dec	delay2
	bra	nz,lp256
	return

;------	Delay Routines	------------------------------------------------------	

delay10us:
		repeat	#13
		nop
delay9_5us:
		repeat	#13
		nop
delay9us:
		repeat	#13
		nop
delay8_5us:
		repeat	#13
		nop
delay8us:
		repeat	#13
		nop
delay7_5us:
		repeat	#13
		nop
delay7us:
		repeat	#13
		nop
delay6_5us:
		repeat	#13
		nop
delay6us:
		repeat	#13
		nop
delay5_5us:
		repeat	#13
		nop
delay5us:
		repeat	#13
		nop
delay4_5us:
		repeat	#13
		nop
delay4us:
		repeat	#13
		nop
delay3_5us:
		repeat	#13
		nop
delay3us:
		repeat	#13
		nop
delay2_5us:
		repeat	#70
		nop
delay2us:	return


;----------------------- LCD Message data tables ----------
strings:

.ascii	"  FIXED 20KHz   "	;00
.ascii  "  FIXED 62.5KHz "	;01
.ascii	"  FIXED 125KHz  "	;02
.ascii  "  FIXED 250KHz  "	;03
.ascii	"  FIXED 500KHz  "	;04
.ascii  "  FIXED  1MHz   "	;05
.ascii	"  FIXED  2MHz   "	;06
.ascii	"  FIXED  3MHz   " 	;07
.ascii	"  FIXED  4MHz   " 	;08
.ascii	"  FIXED 4.3MHz  " 	;09
.ascii	"  FIXED  5MHz   " 	;0A
.ascii	"  FIXED  6MHz   " 	;0B
.ascii	"  FIXED 6.5MHz  "	;OC
.ascii	"  MENU          "	;0D
.ascii	"  MENU          "	;0E
.ascii	"  MENU          "	;0F
;--------------
.ascii	"  MENU SELECT   "	;10
.ascii  "  VIDEO SWEEP   "	;11
.ascii	"  SELECT FREQ   "	;12
.ascii	"   SCOPE POS    "	;13
.ascii	"   SCOPE NEG    "	;14
.ascii	"  MENU          "	;15
.ascii	"  MENU          "	;16
.ascii	"  MENU          "	;17
.ascii	"  MENU          "	;18
.ascii	"  MENU          "	;19
.ascii	"  MENU          "	;1A
.ascii	"  MENU          "	;1B
.ascii	"  MENU          "	;1C
.ascii	"  MENU          "	;1D
.ascii	"  MENU          "	;1E
.ascii	"  MENU          "	;1F



  



;------------------------ end of program ---------------------

	.end		

